#ifndef IMAGE_H
#define IMAGE_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <limits.h> 

class Image 
{
public:
    double *data;
	unsigned char *rgb_data;
    int width;
    int height;
	Image();
    void Allocate(int width, int height);
    double Get(int x, int y);
    void Set(int x, int y, double value);
    void Acc(int x, int y, double value);
    void Normalize(double minval, double maxval);
	void WriteCMUfile(char *filename);
	void ReadCMUfile(char *filename);
    void Multacc(Image *kernel, int x, int y, double mult);
	void Convolve(Image *kernel, Image *input, int mult);
	void Convolve_div(Image *kernel, Image *input, int div);
};

#endif
