#include "image_kernels.h"
#include "image_processing.h"

void hsobelImage(Image *cmu_image, Image *processed_image)
{
	HSobel hsobel;
	hsobel.Create();
	processed_image->Allocate(cmu_image->width, cmu_image->height);
	processed_image->Convolve(&hsobel, cmu_image, 1);
}

void vsobelImage(Image *cmu_image, Image *processed_image)
{
	VSobel vsobel;
	vsobel.Create();
	processed_image->Allocate(cmu_image->width, cmu_image->height);
	processed_image->Convolve(&vsobel, cmu_image, 1);
}

void blurImage(Image *cmu_image, Image *processed_image)
{
	Blur blur;
	blur.Create();
	processed_image->Allocate(cmu_image->width, cmu_image->height);
	processed_image->Convolve_div(&blur, cmu_image, 16);
}

void sharpenImage(Image *cmu_image, Image *processed_image)
{
	static Sharpen sharp;
	sharp.Create();
	processed_image->Allocate(cmu_image->width, cmu_image->height);
	processed_image->Convolve(&sharp, cmu_image, 1);
}

void sinc2XImage(Image *cmu_image, Image *processed_image)
{
#define MULT 2
#define PRECISION 15
	Sinc sinc;
	sinc.Create(PRECISION,MULT);
	processed_image->Allocate(cmu_image->width * MULT, cmu_image->height * MULT);
	processed_image->Convolve(&sinc, cmu_image, MULT);
}
